--[[
###############
Inked: keivamp#
###############
]]--
local Inked = LibStub("AceAddon-3.0"):GetAddon("Inked")
local LSM = LibStub("LibSharedMedia-3.0")
local playerColor = RAID_CLASS_COLORS[select(2, UnitClass('player'))]
local InkedColors = {r = playerColor.r*0.75, g = playerColor.g*0.75,b = playerColor.b*0.75,a = 1}
	local addonName, addon = ...
	
 --generate a holder for the config data
	local G, F, C, L = unpack(select(2,...))
  local cfg = CreateFrame("Frame")
  local function TestFunc()

 end
  -----------------------------
  -- ACTIONBUTTON CONFIG
  -----------------------------

local ThisTexture = ("Interface\\Addons\\Inked\\Graphics\\Buttons\\InkedButtons")
		

	
  cfg.textures = {

	-- normal            = ThisTexture,			
	
	normal            = "Interface\\Addons\\Inked\\Graphics\\Buttons\\InkedButtons",
    flash             = "Interface\\AddOns\\Inked\\Graphics\\Buttons\\flash",
    highlight         = "Interface\\AddOns\\Inked\\Graphics\\Buttons\\AB_ButtonsHoverTex",
    pushed            = "Interface\\AddOns\\Inked\\Graphics\\Buttons\\AB_ButtonsPushedTex",
    checked           = "Interface\\AddOns\\Inked\\Graphics\\Buttons\\checked",
    equipped          = "Interface\\AddOns\\Inked\\Graphics\\Buttons\\normal",
    buttonback        = "Interface\\AddOns\\Inked\\Graphics\\Buttons\\button_background",
    outer_shadow      = "Interface\\AddOns\\Inked\\Graphics\\Buttons\\outer_shadow",
  }

  cfg.background = {
    showbg            = false,  --show an background image?
    showshadow        = false,  --show an outer shadow?
    backgroundcolor   = { r = 0, g = 0, b = 0, a = 0},
    shadowcolor       = { r = 0, g = 0, b = 0, a = 0},
    inset             = -2,  
	padding           = -1,  
  }

  cfg.color = {
     normal            = { r = InkedColors.r, g = InkedColors.g, b = InkedColors.b, },
	-- normal            = { r = 0.15, g = 0, b = 0.2, },
    equipped          = { r = 0.1, g = 0.5, b = 0.1, },
  }

  cfg.hotkeys = {
    show            = false,
    fontsize        = 14,
    pos1             = { a1 = "TOPRIGHT", x = -2, y = -4 },
    pos2             = { a1 = "TOPLEFT", x = -2, y = -4 }, 
  }

  cfg.macroname = {
    show            = true,
    fontsize        = 14,
    pos1             = { a1 = "BOTTOMLEFT", x = 0, y = 4 },
    pos2             = { a1 = "BOTTOMRIGHT", x = 0, y = 4 }, --important! two points are needed to make the macroname be inside of the button
  }

  cfg.itemcount = {
    show            = true,
    fontsize        = 14,
    pos1             = { a1 = "BOTTOMRIGHT", x = 0, y = 2 },
  }

  cfg.cooldown = {
    spacing         = 0,
  }

  cfg.icon = {
    padding = 1,
  }
  
  cfg.font = STANDARD_TEXT_FONT
  ---------------------------------------
  -- VARIABLES
  ---------------------------------------
   
  --backdrop settings
  local bgfile, edgefile = "", ""
  if cfg.background.showshadow then edgefile = cfg.textures.outer_shadow end

  --backdrop
  local backdrop = {
    bgFile = bgfile,
    edgeFile = edgefile,
    tile = false,
    tileSize = 32,
    edgeSize = cfg.background.inset,
    insets = {
      left = cfg.background.inset,
      right = cfg.background.inset,
      top = cfg.background.inset,
      bottom = cfg.background.inset,
    },
  }

  ---------------------------------------
  -- FUNCTIONS
  ---------------------------------------

  local function applyBackground(bu)

    if not bu or (bu and bu.bg) then return end
    --shadows+background
    if bu:GetFrameLevel() < 1 then bu:SetFrameLevel(1) end
    if cfg.background.showbg or cfg.background.showshadow then
      bu.bg = CreateFrame("Frame", nil, bu)
      bu.bg:SetAllPoints(bu)
      bu.bg:SetPoint("TOPLEFT", bu, "TOPLEFT", -cfg.background.padding, cfg.background.padding) 
      bu.bg:SetPoint("BOTTOMRIGHT", bu, "BOTTOMRIGHT", cfg.background.padding, -cfg.background.padding)
      bu.bg:SetFrameLevel(bu:GetFrameLevel()-1)
      if cfg.background.showbg then
        local t = bu.bg:CreateTexture(nil,"BACKGROUND",-8)
        t:SetTexture(cfg.textures.buttonback)
        t:SetAllPoints(bu)
        t:SetVertexColor(cfg.background.backgroundcolor.r,cfg.background.backgroundcolor.g,cfg.background.backgroundcolor.b,0)
      end
      bu.bg:SetBackdrop(backdrop)
      if cfg.background.showshadow then
        bu.bg:SetBackdropBorderColor(cfg.background.shadowcolor.r,cfg.background.shadowcolor.g,cfg.background.shadowcolor.b,0)
      end
    end
  end

  --style extraactionbutton
  local function styleExtraActionButton(bu)

    if not bu or (bu and bu.rabs_styled) then return end
    local name = bu:GetName()
    local ho = _G[name.."HotKey"]
    --remove the style background theme
    bu.style:SetTexture(nil)
    hooksecurefunc(bu.style, "SetTexture", function(self, texture)
      if texture then
        --print("reseting texture: "..texture)
        self:SetTexture(nil)
      end
    end)
    --icon
    bu.icon:SetTexCoord(0.1,0.9,0.1,0.9)
    bu.icon:SetAllPoints(bu)
    --cooldown
    bu.cooldown:SetAllPoints(bu.icon)
    --hotkey
    ho:Hide()
    --add button normaltexture
	bu:SetHighlightTexture(cfg.textures.highlight)
    bu:SetPushedTexture(cfg.textures.pushed)
    bu:SetCheckedTexture(cfg.textures.pushed)
    bu:SetNormalTexture(cfg.textures.normal)
	bu:SetSize(52,52)
    local nt = bu:GetNormalTexture()
	
	if Inked.db.profile.ClassABColor == true then
				nt:SetVertexColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
			elseif Inked.db.profile.ClassABColor == false then
				if Inked.db.profile.CustomABColor == true then
					nt:SetVertexColor(Inked.db.profile.ABColorR,Inked.db.profile.ABColorG,Inked.db.profile.ABColorB,Inked.db.profile.ABColorA)
				elseif Inked.db.profile.CustomABColor == false then
					nt:SetVertexColor(1,1,1,1)
				end
			end
		  
    nt:SetAllPoints(bu)
	hooksecurefunc(nt, "SetVertexColor", function(nt, r, g, b, a)
      local bu = nt:GetParent()
      local action = bu.action
      --print("bu"..bu:GetName().."R"..r.."G"..g.."B"..b)
      if r==1 and g==1 and b==1 and ExtraActionButton1 then
        if cfg.color.equipped.r == 1 and  cfg.color.equipped.g == 1 and  cfg.color.equipped.b == 1 then
          nt:SetVertexColor(0.999,0.999,0.999,1)
        else
          nt:SetVertexColor(cfg.color.normal.r,cfg.color.normal.g,cfg.color.normal.b,1)
        end
      elseif r==0.5 and g==0.5 and b==1 then
        --blizzard oom color
        if cfg.color.normal.r == 0.5 and  cfg.color.normal.g == 0.5 and  cfg.color.normal.b == 1 then
          nt:SetVertexColor(0.499,0.499,0.999,1)
        else
          nt:SetVertexColor(cfg.color.normal.r,cfg.color.normal.g,cfg.color.normal.b,1)
        end
      elseif r==1 and g==1 and b==1 then
        if cfg.color.normal.r == 1 and  cfg.color.normal.g == 1 and  cfg.color.normal.b == 1 then
          nt:SetVertexColor(0.999,0.999,0.999,1)
        else
         if Inked.db.profile.ClassABColor == true then
				nt:SetVertexColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
			elseif Inked.db.profile.ClassABColor == false then
				if Inked.db.profile.CustomABColor == true then
					nt:SetVertexColor(Inked.db.profile.ABColorR,Inked.db.profile.ABColorG,Inked.db.profile.ABColorB,Inked.db.profile.ABColorA)
				elseif Inked.db.profile.CustomABColor == false then
					nt:SetVertexColor(1,1,1,1)
				end
			end
        end
      end
    end)
    --apply background
    if not bu.bg then applyBackground(bu) end
    bu.rabs_styled = true
  end

  --initial style func
  local function styleActionButton(bu)
 

    if not bu or (bu and bu.rabs_styled) then
      return
    end
    local action = bu.action
    local name = bu:GetName()
    local ic  = _G[name.."Icon"]
    local co  = _G[name.."Count"]
    local bo  = _G[name.."Border"]
    local ho  = _G[name.."HotKey"]
    local cd  = _G[name.."Cooldown"]
    local na  = _G[name.."Name"]
    local fl  = _G[name.."Flash"]
    local nt  = _G[name.."NormalTexture"]
    local fbg  = _G[name.."FloatingBG"]
    local fob = _G[name.."FlyoutBorder"]
    local fobs = _G[name.."FlyoutBorderShadow"]
    if fbg then fbg:Hide() end  --floating background
   --fbg:Hide()
    --flyout border stuff
    if fob then fob:SetTexture(nil) end
    if fobs then fobs:SetTexture(nil) end
   -- bo:SetTexture(nil) --hide the border (plain ugly, sry blizz)
   bo:Hide()
    --hotkey
     ho:SetFont("Interface\\Addons\\Inked\\Fonts\\SF Comic Script.TTF", 16, "OUTLINE")
	
     ho:ClearAllPoints()
     ho:SetPoint(cfg.hotkeys.pos1.a1,bu,cfg.hotkeys.pos1.x,cfg.hotkeys.pos1.y)
     ho:SetPoint(cfg.hotkeys.pos2.a1,bu,cfg.hotkeys.pos2.x,cfg.hotkeys.pos2.y)
	--ho:Show()

    --applying the textures
    fl:SetTexture(cfg.textures.flash)
    bu:SetHighlightTexture(cfg.textures.highlight)
    bu:SetPushedTexture(cfg.textures.pushed)
    bu:SetCheckedTexture(cfg.textures.checked)
    bu:SetNormalTexture(cfg.textures.normal)
    if not nt then
      --fix the non existent texture problem (no clue what is causing this)
      nt = bu:GetNormalTexture()
    end
    --cut the default border of the icons and make them shiny
    ic:SetTexCoord(0.1,0.9,0.1,0.9)
    ic:SetPoint("TOPLEFT", bu, "TOPLEFT", cfg.icon.padding, -cfg.icon.padding)  --图标与背景边框之间的空隙
    ic:SetPoint("BOTTOMRIGHT", bu, "BOTTOMRIGHT", -cfg.icon.padding, cfg.icon.padding)
    --adjust the cooldown frame
    cd:SetPoint("TOPLEFT", bu, "TOPLEFT", cfg.cooldown.spacing, -cfg.cooldown.spacing)
    cd:SetPoint("BOTTOMRIGHT", bu, "BOTTOMRIGHT", -cfg.cooldown.spacing, cfg.cooldown.spacing)
    --apply the normaltexture
    if action and IsEquippedAction(action) then
      bu:SetNormalTexture(cfg.textures.equipped)
      nt:SetVertexColor(0,0,0,1)
    else
      bu:SetNormalTexture(cfg.textures.normal)
      nt:SetVertexColor(Inked.db.profile.ABColorR,Inked.db.profile.ABColorG,Inked.db.profile.ABColorB,Inked.db.profile.ABColorA)
    end
    --make the normaltexture match the buttonsize
	if bu ~= nil then
    nt:SetAllPoints(bu)
	end
    --hook to prevent Blizzard from reseting our colors
    hooksecurefunc(nt, "SetVertexColor", function(nt, r, g, b, a)
      local bu = nt:GetParent()
      local action = bu.action
      --print("bu"..bu:GetName().."R"..r.."G"..g.."B"..b)
      if r==1 and g==1 and b==1 and action and (IsEquippedAction(action)) then
        if cfg.color.equipped.r == 1 and  cfg.color.equipped.g == 1 and  cfg.color.equipped.b == 1 then
          nt:SetVertexColor(0.999,0.999,0.999,1)
        else
          nt:SetVertexColor(cfg.color.equipped.r,cfg.color.equipped.g,cfg.color.equipped.b,1)
        end
      elseif r==0.5 and g==0.5 and b==1 then
        --blizzard oom color
        if cfg.color.normal.r == 0.5 and  cfg.color.normal.g == 0.5 and  cfg.color.normal.b == 1 then
          nt:SetVertexColor(0.499,0.499,0.999,1)
        else
          nt:SetVertexColor(cfg.color.normal.r,cfg.color.normal.g,cfg.color.normal.b,1)
        end
      elseif r==1 and g==1 and b==1 then
        if cfg.color.normal.r == 1 and  cfg.color.normal.g == 1 and  cfg.color.normal.b == 1 then
          nt:SetVertexColor(0.999,0.999,0.999,1)
        else
          if Inked.db.profile.ClassABColor == true then
				nt:SetVertexColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
			elseif Inked.db.profile.ClassABColor == false then
				if Inked.db.profile.CustomABColor == true then
					nt:SetVertexColor(Inked.db.profile.ABColorR,Inked.db.profile.ABColorG,Inked.db.profile.ABColorB,Inked.db.profile.ABColorA)
				elseif Inked.db.profile.CustomABColor == false then
					nt:SetVertexColor(1,1,1,1)
				end
			end
        end
      end
    end)
    --shadows+background
    if not bu.bg then applyBackground(bu) end
    bu.rabs_styled = true
  end

  local function styleLeaveButton(bu)
    if not bu or (bu and bu.rabs_styled) then return end
    --shadows+background
    if not bu.bg then applyBackground(bu) end
    bu.rabs_styled = true
  end  
    
  --style pet buttons
  local function stylePetButton(bu)

    if not bu or (bu and bu.rabs_styled) then return end
    local name = bu:GetName()
    local ic  = _G[name.."Icon"]
    local fl  = _G[name.."Flash"]
    local nt  = _G[name.."NormalTexture2"]
	local ho  = _G[name.."HotKey"]
	ho:Hide()
    nt:SetAllPoints(bu)
    --applying color
    nt:SetVertexColor(Inked.db.profile.AB2ColorR,Inked.db.profile.AB2ColorG,Inked.db.profile.AB2ColorB,Inked.db.profile.AB2ColorA)
    --setting the textures
    fl:SetTexture(cfg.textures.flash)
    bu:SetHighlightTexture(cfg.textures.highlight)
    bu:SetPushedTexture(cfg.textures.pushed)
    bu:SetCheckedTexture(cfg.textures.checked)
    bu:SetNormalTexture(cfg.textures.normal)
    hooksecurefunc(bu, "SetNormalTexture", function(self, texture)
      --make sure the normaltexture stays the way we want it
      if texture and texture ~= cfg.textures.normal then
        self:SetNormalTexture(cfg.textures.normal)
      end
    end)
    --cut the default border of the icons and make them shiny
    ic:SetTexCoord(0.1,0.9,0.1,0.9)
    ic:SetPoint("TOPLEFT", bu, "TOPLEFT", cfg.icon.padding, -cfg.icon.padding)
    ic:SetPoint("BOTTOMRIGHT", bu, "BOTTOMRIGHT", -cfg.icon.padding, cfg.icon.padding)
    --shadows+background
    if not bu.bg then applyBackground(bu) end
    bu.rabs_styled = true
  end

  --style stance buttons
  local function styleStanceButton(bu)
    if not bu or (bu and bu.rabs_styled) then return end
    local name = bu:GetName()
    local ic  = _G[name.."Icon"]
    local fl  = _G[name.."Flash"]
    local nt  = _G[name.."NormalTexture2"]
    nt:SetAllPoints(bu)
    --applying color
    nt:SetVertexColor(Inked.db.profile.AB2ColorR,Inked.db.profile.AB2ColorG,Inked.db.profile.AB2ColorB,Inked.db.profile.AB2ColorA)
    --setting the textures
    fl:SetTexture(cfg.textures.flash)
    bu:SetHighlightTexture(cfg.textures.highlight)
    bu:SetPushedTexture(cfg.textures.pushed)
    bu:SetCheckedTexture(cfg.textures.checked)
    bu:SetNormalTexture(cfg.textures.normal)
    --cut the default border of the icons and make them shiny
    ic:SetTexCoord(0.1,0.9,0.1,0.9)
    ic:SetPoint("TOPLEFT", bu, "TOPLEFT", cfg.icon.padding, -cfg.icon.padding)
    ic:SetPoint("BOTTOMRIGHT", bu, "BOTTOMRIGHT", -cfg.icon.padding, cfg.icon.padding)
    --shadows+background
    if not bu.bg then applyBackground(bu) end
    bu.rabs_styled = true
  end

  --style possess buttons
  local function stylePossessButton(bu)

    if not bu or (bu and bu.rabs_styled) then return end
    local name = bu:GetName()
    local ic  = _G[name.."Icon"]
    local fl  = _G[name.."Flash"]
    local nt  = _G[name.."NormalTexture"]
    nt:SetAllPoints(bu)
    --applying color
    nt:SetVertexColor(Inked.db.profile.AB2ColorR,Inked.db.profile.AB2ColorG,Inked.db.profile.AB2ColorB,Inked.db.profile.AB2ColorA)
    --setting the textures
    fl:SetTexture(cfg.textures.flash)
    bu:SetHighlightTexture(cfg.textures.highlight)
    bu:SetPushedTexture(cfg.textures.pushed)
    bu:SetCheckedTexture(cfg.textures.checked)
    bu:SetNormalTexture(cfg.textures.normal)
    --cut the default border of the icons and make them shiny
    ic:SetTexCoord(0.1,0.9,0.1,0.9)
    ic:SetPoint("TOPLEFT", bu, "TOPLEFT", cfg.icon.padding, -cfg.icon.padding)
    ic:SetPoint("BOTTOMRIGHT", bu, "BOTTOMRIGHT", -cfg.icon.padding, cfg.icon.padding)
    --shadows+background
    if not bu.bg then applyBackground(bu) end
    bu.rabs_styled = true
  end
 
  --update hotkey func
  local function updateHotkey(self, actionButtonType)
    -- local ho = _G[self:GetName().."HotKey"]
    -- if ho and not cfg.hotkeys.show and ho:IsShown() then
      -- ho:Hide()
    -- end
  end

  ---------------------------------------
  -- INIT
  ---------------------------------------

  local function init()

    for i = 1, 12 do
     styleActionButton(_G["ActionButton"..i])
     styleActionButton(_G["MultiBarBottomLeftButton"..i])
      styleActionButton(_G["MultiBarBottomRightButton"..i])
      styleActionButton(_G["MultiBarRightButton"..i])
      styleActionButton(_G["MultiBarLeftButton"..i])
    end
    for i = 1, 6 do
      styleActionButton(_G["OverrideActionBarButton"..i])
    end
	--style bags++++
    for i = 0, 3 do
	 -- styleBag(_G["CharacterBag"..i.."Slot"])
    end
	--styleBag(MainMenuBarBackpackButton)
    --style leave button
    styleLeaveButton(OverrideActionBarLeaveFrameLeaveButton)
    styleLeaveButton(rABS_LeaveVehicleButton)
--	styleLeaveButton(MainMenuBarVehicleLeaveButton)--++++
    --petbar buttons
    for i=1, NUM_PET_ACTION_SLOTS do
      stylePetButton(_G["PetActionButton"..i])
    end
    --stancebar buttons
    for i=1, NUM_STANCE_SLOTS do
      styleStanceButton(_G["StanceButton"..i])
    end

    styleExtraActionButton(ExtraActionButton1)

	

     -- hooksecurefunc("ActionButton_UpdateHotkeys",  updateHotkey)
	-- hooksecurefunc(button, 'Update', updateHotkey)
	


  end


  ---------------------------------------
  -- CALL
  ---------------------------------------

  local a = CreateFrame("Frame")
 
  a:RegisterEvent("PLAYER_LOGIN")

  
  a:SetScript("OnEvent", init)